﻿@{
    ViewBag.Title = "Risk Register";
    Layout = "~/Views/Shared/_FixedLayout.cshtml";
}

<link href="~/Content/plugins/bootstrap-datepicker/css/bootstrap-datepicker.css" rel="stylesheet" />
<script src="~/Content/plugins/bootstrap-datepicker/js/bootstrap-datepicker.js"></script>
<link href="~/Content/plugins/bootstrap-combobox/css/bootstrap-combobox.css" rel="stylesheet" />
<script src="~/Content/plugins/bootstrap-combobox/js/bootstrap-combobox.js"></script>

<link href="~/Content/plugins/datatables/css/dataTables.bootstrap.css" rel="stylesheet" />
<script src="~/Content/plugins/datatables/js/jquery.dataTables.min.js"></script>
<script src="~/Content/plugins/datatables/js/jquery.dataTables.columnFilter.js"></script>
<script src="~/Content/plugins/datatables/js/dataTables.bootstrap.js"></script>

<script type="text/javascript">


    var oTable;


    $(document).ready(function () {
        var aryColTableChecked = [];
        for (var idx = 1; idx < 10; idx++) {
            aryColTableChecked.push("field" + idx);

        }

        var aoColumnDef = [];

        $.each(aryColTableChecked, function (i, value) {

            var obj = {
                "mData": value, "aTargets": [i]
            }

            if (i == 7) {
                var obj = {
                    "mData": value
                    , "visible": false
                    , "aTargets": [i]
                    , "searchable": false
                }
            }

            if (i == 8) {
                
                var obj = {
                    "mData": value,
                    "aTargets": [i],
                    "mRender": function (data, type, row) {
                        if ('@ViewBag.Delete' == "1") {
                            return '<a class="btn btn-primary btn-xs tblButton" name="btnEdit" aria-label="Edit" data-id="' + data + '" ><i class="glyphicon glyphicon-pencil"></i> Detail </a>' +
                                '&nbsp;<a class="btn btn-primary btn-xs tblButton" name = "btnDelete" aria-label="Delete" data-id="' + data + '" ><i class="glyphicon glyphicon-trash"></i> Delete </a>';
                        } else {
                            return '<a class="btn btn-primary btn-xs tblButton" name="btnEdit" aria-label="Edit" data-id="' + data + '" ><i class="glyphicon glyphicon-pencil"></i> Detail </a>';
                        }

                        

                    },
                    "bSortable": false
                }
            }
            aoColumnDef.push(obj);
        });

        $("#btnSearch").click(function () {



            if (oTable != null) {
                oTable.fnDestroy();
            }

            oTable = $('#tblData').dataTable({
                "sAjaxSource": "@Url.Action("GetRiskRegisterList", "RiskRegister")",
                "bServerSide": false,
                "bProcessing": true,
                "bSort": false,
                "bPaginate": true,
                "bLengthChange": false,
                "bStateSave": false,
                "bDestroy": true,
                "bRetrieve": true,
                "fnServerData": function (sSource, aoData, fnCallback) {
                    $.ajax({
                        "dataType": "json",
                        "type": "POST",
                        "url": sSource,
                        "data": aoData,
                        "success": fnCallback
                    });
                },
                "sDom": '<"#tblData_header.clearfix "<"pull-left"l><"pull-right"r>><"table-responsive"t><"#ScrollTop"><"#tblData_footer.clearfix "<"pull-left"i><"pull-right"p>>',
                "fnServerParams": function (aoData) {
                    aoData.push({ "name": "riskno", "value": $('#txtriskno').val() });
                    aoData.push({ "name": "year", "value": "" });
                },
                "aoColumnDefs": aoColumnDef,
                "iDisplayLength": 10,
                "oLanguage": {
                    "sProcessing": '<i class="fa fa-spinner fa-spin"></i> Retrieve Data ... ',
                    "sLengthMenu": '_MENU_'
                },
            });

            oTable.fnSettings().aoColumns[0].sClass = "text-center";
            oTable.fnSettings().aoColumns[1].sClass = "text-center";
            oTable.fnSettings().aoColumns[2].sClass = "text-center";
            oTable.fnSettings().aoColumns[3].sClass = "text-left";
            oTable.fnSettings().aoColumns[4].sClass = "text-center";
            oTable.fnSettings().aoColumns[5].sClass = "text-center";
            oTable.fnSettings().aoColumns[6].sClass = "text-center";
            oTable.fnSettings().aoColumns[7].sClass = "text-center";
            oTable.fnSettings().aoColumns[8].sClass = "text-center";


            $('#tblData tbody').on('click', 'a', function () {

                var table = $('#tblData').DataTable();
                var row = table.row($(this).parents('tr')).data();
                var action = $(this).attr('aria-label');
                var rowid = row['field8'].split("#")[0];
                var status = row['field7'].split("#")[0];

                if (action == 'Edit') {
                    if (status == "Pending Approval") {
                        window.location.href = '@Url.Action("EditRiskRegisterApprover", "RiskRegister")?id=' + rowid;
                    } else {
                        window.location.href = '@Url.Action("EditRiskRegister", "RiskRegister")?id=' + rowid;
                    }



                }
                if (action == 'Delete') {
                    bootbox.confirm({
                        title: "<i class='fa fa-warning fa-2x'></i> Delete Confirmation",
                        message: 'Are you sure you want to delete this data.',
                        className: "medium",
                        buttons: {
                            'cancel': {
                                label: '<i class="fa fa-times"></i> Cancel',
                                className: 'btn-default pull-left'
                            },
                            'confirm': {
                                label: '<i class="fa fa-check"></i> Yes, Continue delete',
                                className: 'btn-primary pull-right'
                            }
                        },
                        callback: function (result) {
                            if (result) {
                                var url = '@Url.Action("DeleteRiskRegister", "RiskRegister")?rowid=' + rowid;
                                $.ajax(url, {
                                    contentType: 'application/json; charset=utf-8',
                                    dataType: 'json',
                                    type: 'POST',
                                    success: function (url) {
                                        if (url.success) {
                                            //$("#btnSearch").click();
                                            location.reload(true);
                                        }
                                    },
                                    error: function () {

                                    }
                                });
                            }

                        }
                    });
                }

            });

           
        });

        $("#btnReset").click(function () {

            //document.getElementById("txtyear").value = "";
            document.getElementById("txtriskno").value = "";

            $("#btnSearch").click();
        });


    });

    $(function () {
        $('#btnSearch').click();
    });
</script>

<style>
    .label-def-margin {
        margin-top: 10px;
    }
</style>


<div class="col-sm-12">
   <div class="panel panel-primary" style="margin-bottom: 0;">
        <div class="panel-heading">
            Search
        </div>
        <div class="panel-body">
            <div class="row">
                <!--Year
                <div class="col-sm-1"><label class="label-def-margin" for="txtyear">Year</label></div>
                <div class="col-sm-3"><input class="form-control" id="txtyear" type="text" /></div>
                    -->
                <!--KPI No-->
                <div class="col-sm-1"><label class="label-def-margin" for="txtriskno">Risk No</label></div>
                <div class="col-sm-3"><input class="form-control" id="txtriskno" type="text" /></div>
            </div>
            <br />
            <div class="row">
                <div class="col-sm-1">
                    <button type="button" class="btn btn-primary" id="btnSearch">
                        <span class="glyphicon glyphicon-search"></span> Search
                    </button>
                </div>
                <div class="col-sm-1">
                    <button type="button" class="btn btn-primary" id="btnReset">
                        <span class="glyphicon glyphicon-refresh"></span> Reset
                    </button>
                </div>
            </div>
        </div>
    </div>
    <br />
    <div class="panel panel-primary">
        <div class="panel-body">
            <table id="tblData" class="table table-striped table-hover table-bordered" width="100%" style="font-size: 10px; margin-top: 0 !important; margin-bottom: 0 !important; padding-top: 0 !important; padding-bottom: 0 !important;">
                <thead class="bg-mantle-gradient">
                    <tr>
                        <th>&nbsp;No&nbsp;</th>
                        <th>Risk No</th>
                        <th>Loss</th>
                        <th>Caused</th>
                        <th>Risk Impact</th>
                        <th>Risk Level</th>
                        <th>Status</th>
                        <th>RecId</th>
                        <th>Action</th>
                    </tr>
                </thead>
            </table>
        </div>
    </div>
</div>
